#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDrag>
#include <QMimeData>
#include <QDragEnterEvent>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    area = new Area;
    area->acceptDrops();
    area->setParent (ui->base);
    QSize s = ui->base->size();
    area->setGeometry(4, 4, s.width()-8, s.height()-8);

    QPalette palette;
    QBrush brush1 (QColor (255, 255, 155));
    brush1.setStyle (Qt::SolidPattern);
    palette.setBrush (QPalette::Active, QPalette::Window, brush1);
    area->setPalette (palette);
    area->setAutoFillBackground (true);

    ui->toolbox->addTopLevelItem (new ButtonFactory);
    ui->toolbox->addTopLevelItem (new EditFactory);
}

MainWindow::~MainWindow()
{
    delete ui;
}

// #include <QDrag>
// #include <QMimeData>

void MainWindow::on_toolbox_itemPressed (QTreeWidgetItem *item, int column)
{
    QDrag * drag = new QDrag (this);
    QMimeData * mimeData = new QMimeData ();
    mimeData->setText ("Hello");
    drag->setMimeData (mimeData);
    drag->exec (Qt::CopyAction | Qt::MoveAction | Qt::LinkAction);
}

void Area::dragEnterEvent (QDragEnterEvent * event)
{
    event->setAccepted (true);
}
